/*
   A little input demo
 */

#include <stdio.h>
#include <comedilib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <getopt.h>
#include <ctype.h>


int subdevice = 0;
int channel = 0;
double freq = 10000;

#define N_SAMPLES	10000

sampl_t data[N_SAMPLES];


int main(int argc, char *argv[])
{
	char *fn = NULL;
	comedi_trig it;
	unsigned int chan;
	int err;
	int n;
	comedi_t *dev;
	double actual_freq;

	fn = "/dev/comedi0";

	dev = comedi_open(fn);

	it.subdev = 0;
	it.mode = 1;
	it.flags = 0;
	it.n_chan = 1;
	it.chanlist = &chan;
	it.data = data;
	it.n = N_SAMPLES;
	it.trigsrc = 0;

	comedi_get_timer(dev,subdevice,freq,&it.trigvar,&actual_freq);
	printf("actual frequency=%g timer value=%d\n",actual_freq,it.trigvar);

	it.trigvar1 = 0;

	chan = CR_PACK(0, 0, 3);

	if ((err = ioctl(dev->fd, COMEDI_TRIG, &it)) < 0) {
		perror("ioctl");
		exit(1);
	}

	if((n=read(dev->fd,data,N_SAMPLES*sizeof(sampl_t)))<0){
		perror("read");
		exit(1);
	}
	printf("number of samples read=%d\ndata[0]=%d\ndata[N-1]=%d\n",
		n/sizeof(sampl_t),data[0],data[N_SAMPLES-1]);

	return 0;
}

